<template>
    <div class="container mt-5">
        <div class="card">
            <div class="card-header">
                <h4>Edit Genre</h4>
            </div>
            <div class="card-body">

                <ul class="alert alert-warning" v-if="Object.keys(this.errorList).length > 0">
                    <li class="mb-0 ms-3" v-for="(error, index) in this.errorList" :key="index">
                        {{ error[0] }}
                    </li>
                </ul>

                <div class="mb-3">
                    <label for="" class="mb-2">Name</label>
                    <input type="text" v-model="model.genre.name" class="form-control" />
                </div>
                <div class="mb-3">
                    <img src="../../assets/app_icon.png" class="logo">
                </div>
                <div class="action-buttons-container mb-3">
                    <RouterLink :to="{ path: '/genres' }" class="btn btn-secondary my-button mx-2">Back</RouterLink>
                    <button type="button" @click="updateGenre()" class="btn btn-success my-button">Update</button>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';

export default {
    name: "genreEdit",
    data() {
        return {
            genreId: '',
            errorList: '',
            model: {
                genre: {
                    name: ''
                }
            }
        }
    },
    mounted() {
        console.log(this.$route.params.id);
        this.genreId = this.$route.params.id;
        this.getGenreData(this.$route.params.id);
    },
    methods: {
        getGenreData(genreId) {
            axios.get(`http://localhost:8000/api/genres/${genreId}/edit`, {
                headers: {
                    'Authorization': localStorage.getItem('token'),
                    'Accept': 'application/json'
                }
            }).then(res => {
                console.log(res.data);
                // this.model.genre.name = res.data.data.name;
                this.model.genre = res.data.data;
            }).catch(function (error) {
                if (error.response) {
                    if (error.response.status == 404) {
                        // $this.errorList = error.response.data.errors;
                        alert(error.response.data.message);
                    }
                }
            });
        },

        updateGenre() {
            var $this = this;
            axios.put(`http://localhost:8000/api/genres/${this.genreId}/edit`, this.model.genre, {
                headers: {
                    'Authorization': localStorage.getItem('token'),
                    'Accept': 'application/json'
                }
            }).then(res => {
                console.log(res.data);
                alert(res.data.message);

                this.errorList = '';
                this.$router.push({ path: '/genres' });
            }).catch(function (error) {
                if (error.response) {
                    if (error.response.status == 422) {
                        $this.errorList = error.response.data.errors;
                    } else if (error.response.status == 404 || error.response.status == 500) {
                        alert(error.response.data.message);
                    }
                } else if (error.request) {
                    console.log(error.request);
                } else {
                    console.log('Error', error.message);
                }
            });
        }
    }
}
</script>

<style>
.logo{
    display: block;
    margin: 0 auto;
    height: 36vh;
}

.btn-primary,
.btn-primary:hover,
.btn-primary:focus-visible {
    background: #474646 !important;
    border-color: #474646 !important;
}

.my-button{
    width:6rem;
}

.action-buttons-container {
    float:right;
}
</style>